﻿using System;
using System.Data;

using Infragistics.Web.UI.GridControls;

public partial class _Default : System.Web.UI.Page
{
    public DataSet populateWHDG()
    {
        var ds = new DataSet();
        var parent = new DataTable { TableName = "Parent" };
        var child = new DataTable { TableName = "Child" };

        parent.Columns.Add("ID", typeof(int));
        parent.Columns.Add("Age", typeof(int));
        parent.Columns.Add("Name", typeof(string));
        parent.Columns.Add("Price", typeof(double));

        var col = new DataColumn[1];
        col[0] = parent.Columns["ID"];
        parent.PrimaryKey = col;

        var row = parent.NewRow();
        row.SetField("ID", 0);
        row.SetField("Age", 23);
        row.SetField("Name", "Alice");
        row.SetField<double>("Price", 39);
        parent.Rows.Add(row);

        row = parent.NewRow();
        row.SetField("ID", 1);
        row.SetField("Age", 23);
        row.SetField("Name", "Mark");
        row.SetField<double>("Price", 56);
        parent.Rows.Add(row);

        row = parent.NewRow();
        row.SetField("ID", 2);
        row.SetField("Age", 23);
        row.SetField("Name", "Toni");
        row.SetField<double>("Price", 23);
        parent.Rows.Add(row);

        row = parent.NewRow();
        row.SetField("ID", 3);
        row.SetField("Age", 44);
        row.SetField("Name", "Bob");
        row.SetField<double>("Price", 66);
        parent.Rows.Add(row);

        child.Columns.Add("ID", typeof(int));
        child.Columns.Add("Address", typeof(string));
        child.Columns.Add("Count", typeof(int));

        row = child.NewRow();
        row.SetField("ID", 0);
        row.SetField("Address", "Paris");
        row.SetField("Count", 5);
        child.Rows.Add(row);

        row = child.NewRow();
        row.SetField("ID", 1);
        row.SetField("Address", "Rome");
        row.SetField("Count", 9);
        child.Rows.Add(row);

        row = child.NewRow();
        row.SetField("ID", 1);
        row.SetField("Address", "London");
        row.SetField("Count", 2);
        child.Rows.Add(row);

        row = child.NewRow();
        row.SetField("ID", 0);
        row.SetField("Address", "LosAngeles");
        row.SetField("Count", 9);
        child.Rows.Add(row);

        ds.Tables.Add(parent);
        ds.Tables.Add(child);

        var relation = new DataRelation("IDRelation", parent.Columns["ID"], child.Columns["ID"]);
        ds.Relations.Add(relation);

        return ds;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        this.WebHierarchicalDataGrid1.GroupingSettings.GroupedColumns.Add("Age");
        this.WebHierarchicalDataGrid1.DataSource = populateWHDG();

        this.WebHierarchicalDataGrid1.DataBind();
    }

    protected void WebHierarchicalDataGrid1_GroupedRowInitialized(object sender, GroupedRowEventArgs e)
    {
        double sumRecords = 0;
        
        // Getting the value that the column is grouped by
        string groupByVal = e.GroupedRow.Value.ToString();

        // Loop thought grid rows to find which rows are being included in the group
        foreach (ContainerGridRecord row in WebHierarchicalDataGrid1.Rows)
        {
            if (row.Items[1].Text == groupByVal)
            {
                sumRecords += Convert.ToDouble(row.Items[3].Value);
            }
        }

        e.GroupedRow.Text = e.GroupedRow.Text + "  " + "Total Price: " + sumRecords;
    }
}